
function Response(codeMap) {
    this.codeMap = codeMap;
};

var prototype = Response.prototype;

/**
 * sucess
 * @param {Array|String|Number} data 返回的数据
 * @param {String} msg 返回的msg
 * @param {String} debugMsg 调试的msg
 * @author benzhan
 */
prototype.success = function(data, msg, debugMsg) {
    var code = this.code = CODE_SUCCESS;
    this.debugMsg = debugMsg;

    msg = msg || this.codeMap[code];
    if (DEBUG && debugMsg) {
        msg = msg + " 【调试信息:" + debugMsg + "】";
    }

    var ret = {
        result : 1,
        code : code,
        msg : msg,
        data : data
    };

    this.exitData(ret);
};

/**
 * error with code
 * @param {Number} code
 * @param {String} msg
 * @param {String} debugMsg
 * @param {String} extData
 * @author benzhan
 */
prototype.error = function(code, msg, debugMsg, extData) {
    this.code = code;
    this.debugMsg = debugMsg;

    msg = msg || this.codeMap[code];
    if (DEBUG && debugMsg) {
        msg = msg + " 【调试信息:" + debugMsg + "】";
    }

    var ret = {
        result : 0,
        code : code,
        msg : msg,
    };

    if (extData) {
        ret['data'] = extData;
    }

    this.exitData(ret);
};

prototype.exitData = function(ret) {
    var json = JSON.stringify(ret);
    _res.header('Content-Type', 'application/json');
    this.exitMsg(json, ret['code']);
};

prototype.exitMsg = function(content, code) {
    this.code = code || CODE_SUCCESS;
    //jquery jsonp callback处理
    if(_req.query && _req.query.callback) {
        if(new RegExp(/^jQuery(\d+)_(\d+)$/).test(_req.query.callback)) {
            content = _req.query.callback + '(' + content + ');';
        }
    }
    _res.write(content);
    _res.end();
};

module.exports = Response;
