
var php = require('phpjs');

function Router(url) {
    //var parts = url.match("http[s]*://[^/]+/([^/]+)/([^/?]+)");
    var parts = url.match("(http[s]*://[^/]+)?/([^/]+)/([^/?]+)");
    if (parts && parts.length >= 4) {
        this.controllerName = parts[2];
        this.actionName = parts[3];
    } else {
        this.controllerName = 'default';
        this.actionName = 'index';
    }

    global['CONTROLLER_NAME'] = this.controllerName;
    global['ACTION_NAME'] = this.actionName;
}

Router.prototype.getControllerName = function() {
    return this.controllerName;
};

Router.prototype.getActionName = function() {
    return this.actionName;
}

Router.prototype.getController = function() {
    var controllerName = php.ucfirst(this.controllerName.toLowerCase()) ;
    var objController;
    try {
        objController = require('../../controllers/' + controllerName + 'Controller.js');
        return objController;
    } catch(ex) {
        console.error(ex);
        return null;
    }
}

Router.prototype.getFullActionName = function () {
    return 'action' + php.ucfirst(this.actionName.toLowerCase());
}

module.exports = Router;
